package com.chinacreator.video.controller;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Set;
import java.util.concurrent.ConcurrentHashMap;
import java.util.concurrent.ConcurrentMap;
import java.io.UnsupportedEncodingException;
import java.lang.reflect.Field;
import java.net.URLDecoder;
import java.net.URLEncoder;

import org.apache.commons.lang.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.cache.CacheManager;
import org.springframework.cache.concurrent.ConcurrentMapCache;
import org.springframework.cache.interceptor.SimpleKey;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import com.chinacreator.video.bean.ECBBean;
import com.chinacreator.video.bean.ECBJoinBean;
import com.chinacreator.video.dto.DataOutPipe;
import com.chinacreator.video.mapper.DictionaryDao;
import com.chinacreator.video.mapper.ECBConfigDao;
import com.chinacreator.video.mapper.ECBJoinConfigDao;
import com.chinacreator.video.util.URLUtil;

@RestController
public class CacheOper {

//	private static List<String> list = new ArrayList<String>();
//
//	@Autowired
//	private  CacheManager cacheManager;
//
//	@Autowired
//	private ECBConfigDao ecbConfigDao;
//
//	@Autowired
//	private ECBJoinConfigDao eCBJoinConfigDao;
//
//	@Autowired
//	private DictionaryDao dictionaryDao;
//
//	static {
//		list.add("http://10.199.99.136:9080/video-activity");
//		list.add("http://10.199.99.160:9080/video-activity");
//		list.add("http://10.199.99.161:9080/video-activity");
//		list.add("http://10.199.99.142:9080/video-activity");
//		list.add("http://10.199.99.141:9080/video-activity");
//		list.add("http://172.16.123.13:9021/video-activity");
//		list.add("http://172.16.123.13:9022/video-activity");
//		list.add("http://172.16.123.14:9021/video-activity");
//		list.add("http://172.16.123.14:9022/video-activity");
//		list.add("http://172.16.123.15:9021/video-activity");
//		list.add("http://172.16.123.15:9022/video-activity");
//		list.add("http://172.16.123.16:9021/video-activity");
//		list.add("http://172.16.123.16:9022/video-activity");
//		list.add("http://172.16.123.21:9021/video-activity");
//		list.add("http://172.16.123.21:9022/video-activity");
//		list.add("http://172.16.123.22:9021/video-activity");
//		list.add("http://172.16.123.22:9022/video-activity");
//		list.add("http://172.16.123.23:9021/video-activity");
//		list.add("http://172.16.123.23:9022/video-activity");
//		list.add("http://172.16.123.24:9021/video-activity");
//		list.add("http://172.16.123.24:9022/video-activity");
//		//list.add("http://172.16.33.16:8083/video-activity");
//	}
//
//
//	/**
//     * Obj 转换为 map
//     * @param obj
//     * @return
//     * @throws Exception
//     */
//    public static Map<String, Object> ObjToMap(Object obj) throws Exception {
//        Map<String, Object> map = new HashMap<>();
//        Field[] fields = obj.getClass().getDeclaredFields();
//        for (Field field : fields) {
//            field.setAccessible(true);
//            map.put(field.getName(), field.get(obj));
//        }
//        return map;
//    }
//
//    /**
//     *
//     * @param cpid
//     * @param spid
//     * @param province
//     * @param activetype
//     * @param cacheName
//     * @param serive local本机，all所有服务器
//     * @return
//     */
//	@RequestMapping("/getCacheData")
//	public List getCacheData(String cpid, String spid, String province,String activetype,String key, String cacheName,String ip) {
//		System.out.println("接收参数：cpid="+cpid+">>spid="+spid+">>province="+province+">>activetype="+activetype+">>cacheName="+cacheName+">>ip="+ip);
//		String params = "";
//	    try {
//	    	//参数中的中文必须转码，否则调用时报异常“The valid characters are defined in RFC 7230 and RFC3986”
//	    	params = "cpid="+cpid+"&spid="+spid+"&province="+URLEncoder.encode(province,"utf-8")+"&activetype="+activetype+"&key="+key+"&cacheName="+cacheName+"&ip=local";
//			System.out.println("++++++++++++++转码后调接口参数："+params);
//			//接收参数：cpid=tencent>>spid=101>>province=辽宁>>activetype=11>>cacheName=ECBJoinConfig>>ip=local
//			//++++++++++++++转码后调接口参数：cpid=tencent&spid=101&province=%E8%BE%BD%E5%AE%81&activetype=11&key=null&cacheName=ECBJoinConfig&ip=local
//		} catch (UnsupportedEncodingException e1) {
//			e1.printStackTrace();
//		}
//		List relist = new ArrayList();
//		if("local".equals(ip)){
//			Object bean = null;
//			if("ECBJoinConfig".equals(cacheName)){
//				bean = eCBJoinConfigDao.queryEcbJoinConfig(cpid, spid, province, activetype);
//			}else if("ECBConfig".equals(cacheName)){
//				bean = ecbConfigDao.queryEcbConfig(cpid, spid, province);
//			}else if("dictionary".equals(cacheName)){
//				bean = dictionaryDao.getValue(key);
//			}
//			relist.add(bean);
//		}else if("all".equals(ip)){
//			System.out.println("========================查询所有应用");
//			for (String invokeUrl : list) {
//				try {
//					String res = URLUtil.get(invokeUrl+"/getCacheData?"+params);
//					relist.add(invokeUrl.replace("/video-activity", "").replace("http://", ""));
//					relist.add(res);
//				} catch (Exception e) {
//					e.printStackTrace();
//				}
//			}
//		}else{
//			System.out.println("========================查询指定应用："+ip);
//			for (String invokeUrl : list) {
//				try {
//					if(ip != null && invokeUrl.indexOf(ip) != -1){
//						String res = URLUtil.get(invokeUrl+"/getCacheData?"+params);
//						relist.add(invokeUrl.replace("/video-activity", "").replace("http://", ""));
//						relist.add(res);
//					}
//				} catch (Exception e) {
//					e.printStackTrace();
//				}
//			}
//		}
//
//		return relist;
//	}
//
//	@RequestMapping("/queryCache")
//	public List queryCache(String ip, String cacheName) {
//		List relist = new ArrayList();
//		try {
//			if("local".equals(ip)){ //清除
//				if("all".equals(cacheName)){
//					for (String tmpcacheName : cacheManager.getCacheNames()) {
//						Map tempMap = new HashMap();
//						List tempList = new ArrayList();
//						org.springframework.cache.Cache c = cacheManager.getCache(tmpcacheName);
//						//System.out.println(c.getClass());
//						org.springframework.cache.concurrent.ConcurrentMapCache currCache = (org.springframework.cache.concurrent.ConcurrentMapCache)c;
//						ConcurrentHashMap<Object, Object> currMap = (ConcurrentHashMap)currCache.getNativeCache();
//						Set keySet = currMap.keySet();
//						for(Iterator it = keySet.iterator(); it.hasNext();){
//							//SimpleKey key = (SimpleKey)it.next();
//							Object key = it.next();
//							System.out.println(key.getClass());
//							//ECBBean value = (ECBBean)currMap.get(key);
//							Object value = currMap.get(key);
//							System.out.println(value.getClass());
//							//System.out.println("+++++++++++++++++key:"+key+"==========value:"+value.getLimit()+">>>"+value.getProvince()+">>>>"+value.getStatus());
//							//relist.add(key.toString());
//							//relist.add(value);
//							tempList.add(key.toString());
//							tempList.add(value);
//							tempMap.put(tmpcacheName, tempList);
//						}
//						relist.add(tempMap);
//					}
//				}else{
//					Map tempMap = new HashMap();
//					List tempList = new ArrayList();
//					org.springframework.cache.Cache c = cacheManager.getCache(cacheName);
//					//System.out.println(c.getClass());
//					org.springframework.cache.concurrent.ConcurrentMapCache currCache = (org.springframework.cache.concurrent.ConcurrentMapCache)c;
//					ConcurrentHashMap<Object, Object> currMap = (ConcurrentHashMap)currCache.getNativeCache();
//					Set keySet = currMap.keySet();
//					for(Iterator it = keySet.iterator(); it.hasNext();){
//						//SimpleKey key = (SimpleKey)it.next();
//						Object key = it.next();
//						System.out.println(key.getClass());
//						Object value = currMap.get(key);
//						System.out.println(value.getClass());
//						//System.out.println("+++++++++++++++++key:"+key+"==========value:"+value.getLimit()+">>>"+value.getProvince()+">>>>"+value.getStatus());
//						//relist.add(key.toString());
//						//relist.add(value);
//						tempList.add(key.toString());
//						tempList.add(value);
//						tempMap.put(cacheName, tempList);
//					}
//					relist.add(tempMap);
//				}
//			}else if("all".equals(ip)){//清除所有服务器缓存
//				for (String invokeUrl : list) {
//					try {
//						String res = URLUtil.get(invokeUrl+"/queryCache?ip=local&cacheName="+cacheName);
//						relist.add(invokeUrl.replace("/video-activity", "").replace("http://", ""));
//						relist.add(res);
//					} catch (Exception e) {
//						e.printStackTrace();
//					}
//				}
//			}else{//指定IP和端口删除指定缓存
//				for (String invokeUrl : list) {
//					try {
//						if(ip != null && invokeUrl.indexOf(ip) != -1){
//							String res = URLUtil.get(invokeUrl+"/queryCache?ip=local&cacheName="+cacheName);
//							relist.add(invokeUrl.replace("/video-activity", "").replace("http://", ""));
//							relist.add(res);
//						}
//					} catch (Exception e) {
//						e.printStackTrace();
//					}
//				}
//			}
//		} catch (Exception e) {
//			e.printStackTrace();
//		}
//
//		return relist;
//	}
//
//
//	@RequestMapping("/cacheOper")
//	public List cacheOper(String ip, String cacheName) {
//		List relist = new ArrayList();
//		if("local".equals(ip)){ //清除
//			int count = 0;
//			if("all".equals(cacheName)){
//				for (String cacheNames : cacheManager.getCacheNames()) {
//					System.out.println(count++);
//					System.out.println(cacheNames);
//					cacheManager.getCache(cacheNames).clear();
//				}
//			}else{
//				System.out.println(count++);
//				System.out.println(cacheName);
//				cacheManager.getCache(cacheName).clear();
//				//System.out.println("==================="+cacheManager.getCache(cacheName));
//			}
//
//			relist.add("cleared，清除条目数："+count);
//		}else if("all".equals(ip)){//清除所有服务器缓存
//			for (String invokeUrl : list) {
//				try {
//					String res = URLUtil.get(invokeUrl+"/cacheOper?ip=local&cacheName="+cacheName);
//					relist.add(invokeUrl.replace("/video-activity", "").replace("http://", ""));
//					relist.add(res);
//				} catch (Exception e) {
//					e.printStackTrace();
//				}
//			}
//		}else{//指定IP和端口删除指定缓存
//			for (String invokeUrl : list) {
//				try {
//					if(invokeUrl.indexOf(ip) != -1){
//						String res = URLUtil.get(invokeUrl+"/cacheOper?ip=local&cacheName="+cacheName);
//						relist.add(invokeUrl.replace("/video-activity", "").replace("http://", ""));
//						relist.add(res);
//					}
//				} catch (Exception e) {
//					e.printStackTrace();
//				}
//			}
//		}
//
//		return relist;
//	}
}
