package com.chinacreator.video.mapper;

import org.apache.ibatis.annotations.Param;


public interface ActiveHBDao {
	
	/**
	 * 查询号段是不是湖北的
	 * 
	 * @param userid
	 * @return
	 */
	int queryHB(@Param("userid")String userid);
	
	int queryHBZW(@Param("userid")String userid);
	
	/**
	 * 领取会员记录
	 * 
	 * @param id
	 * @param userid
	 * @param cpid
	 * @param spid
	 * @param activetype
	 * @param vipstatus
	 */
	int insert(@Param("id")String  id,
			@Param("userid")String  userid,
			@Param("viptype")String viptype,
			@Param("vipid")String vipid,
			@Param("activetype")String activetype,
			@Param("status")String status,
			@Param("channel")String channel);
	
	/**
	 * 是否有领到记录
	 * 
	 * @param userid
	 * @return
	 */
	int getJoinRecord(@Param("userid")String userid);
	
	/**
	 * 查询记录状态
	 * 
	 * @param userid
	 * @return
	 */
    String getRecordStatus(@Param("userid")String userid);
	
	
	/**
	 * 更新领取状态
	 * 
	 * @param userid
	 * @param status
	 * @return
	 */
	int updateJoinStatus(@Param("userid")String userid,@Param("status")String status,@Param("viptype")String viptype,@Param("old")String old,@Param("channel")String channel);
	
	/**
	 * 更新领取状态
	 * 
	 * @param userid
	 * @param status
	 * @return
	 */
	int joinSucceed(@Param("userid")String userid,@Param("status")String status);
}
