package com.chinacreator.video.mapper;

import com.chinacreator.video.bean.ActivityVipConfigBean;
import com.chinacreator.video.bean.VipInfo;
import org.apache.ibatis.annotations.Param;

import java.util.List;

public interface ActivePptvDao {




    /**
     * 会员领取记录
     *
     * @param userid
     * @param cpid
     * @param spid
     * @param activetype
     */
    void insert(
            @Param("userid") String userid,
            @Param("cpid") String cpid,
            @Param("spid") String spid,
            @Param("activetype") String activetype,
            @Param("province") String province,
            @Param("resultcode") String resultcode,
            @Param("errorinfo") String errorinfo
    );


    /**
     * 是否有效订购关系
     *
     * @param userid
     * @param cpid
     * @param spid
     * @return
     */
    int getOrderRelation(@Param("userid") String userid, @Param("cpid") String cpid, @Param("spid") String spid);


    /**
     * 是否已经领取会员
     *
     * @param userid
     * @param cpid
     * @param spid
     * @param activetype
     * @return
     */
    String getJoinActive(@Param("userid") String userid, @Param("cpid") String cpid, @Param("spid") String spid, @Param("activetype") String activetype);

    int updateJoinResult( @Param("resultcode") String resultcode,
                          @Param("errorinfo") String errorinfo,
                          @Param("userid") String userid, @Param("cpid") String cpid, @Param("spid") String spid, @Param("activetype") String activetype);

    String getOrderPrivince(@Param("userid") String userid, @Param("cpid") String cpid, @Param("spid") String spid);

    List<VipInfo> getJoinRecord(@Param("userid") String userid, @Param("cpid") String cpid, @Param("spid") String spid, @Param("activetype") String activetype);


    ActivityVipConfigBean getActiveConfig(@Param("cpid") String cpid, @Param("spid") String spid);


}
