package com.chinacreator.video.mapper;

import org.apache.ibatis.annotations.Param;


public interface ActiveYouku7Dao {
	
	/**
	 * 领取会员记录
	 * 
	 * @param id
	 * @param userid
	 * @param cpid
	 * @param spid
	 * @param activetype
	 * @param vipstatus
	 */
	void insert(@Param("id")String  id,
			@Param("userid")String  userid,
			@Param("cpid")String cpid,
			@Param("spid")String spid,
			@Param("activetype")String activetype,
			@Param("vipstatus")String vipstatus,
			@Param("province")String province);
	
	/**
	 * 是否有效订购关系
	 * 
	 * @param userid
	 * @param cpid
	 * @param spid
	 * @return
	 */
	int getOrderRelation(@Param("userid")String  userid,@Param("cpid")String cpid,@Param("spid")String spid);
	
	/**
	 * 是否已经领取
	 * 
	 * @param userid
	 * @param cpid
	 * @param spid
	 * @param activityType
	 * @return
	 */
	int getJoinVip(@Param("userid")String  userid,@Param("cpid")String cpid,@Param("spid")String spid,@Param("activetype")String activetype);
	
	
	/**
	 * 会员领取总量
	 * 
	 * @param activityType
	 * @return
	 */
	int getActivetypeCount(@Param("cpid")String cpid,@Param("spid")String spid,@Param("activetype")String activetype);
	
	
	String getOrderPrivince(@Param("userid")String  userid,@Param("cpid")String cpid,@Param("spid")String spid);
}
