package com.chinacreator.video.thread;

import java.net.URLEncoder;
import java.util.Date;
import java.util.HashMap;
import java.util.Map;

import com.chinacreator.video.bean.VipInfo;
import com.chinacreator.video.util.AESUtil;
import com.chinacreator.video.util.DesUtil;
import com.chinacreator.video.util.URLUtil;

public class VacQueryThread extends Thread{
	private VipInfo vipinfo;
	
	private static final String MOB_KEY = "ac22273abb2f4960";
	
    public VacQueryThread(VipInfo vipinfo)
    {
    	this.vipinfo = vipinfo;
    }
	
    public void run(){
    	
//    	//测试异步
//    	try {
//    		System.out.println("1>>>>>"+new Date());
//    		sleep(5000);
//    		System.out.println("2>>>>>"+new Date());
//			
//		} catch (Exception e) {
//			e.printStackTrace();
//		}
    	
    	try {
//    		String baseurl = "http://114.255.201.228:86/videoif/vacqry.do";
    		String baseurl = "http://10.199.99.177:8030/videoif/vacqry.do";
    		Map<String,String> param = new HashMap<>();
    		
    		String mobType = vipinfo.getMobtype();
    		String pwd = vipinfo.getPwd();
    		System.out.println("QUERY VAC PWD-----"+pwd);
    		String userid = vipinfo.getUserid();
    		if("1".equals(mobType)) {
    			userid = AESUtil.encrypt(userid, MOB_KEY);
    		}
    		userid =  URLEncoder.encode(DesUtil.encode(userid,  pwd),"utf-8");
    		String channel = vipinfo.getChannel()==null?"":vipinfo.getChannel();
    		
    		param.put("apptype","2");
    		param.put("channel",channel);
    		param.put("userid",userid);
    		param.put("cpid",vipinfo.getCpid());
    		param.put("spid",vipinfo.getSpid());
    		
    		String url = URLUtil.mapToUrl(baseurl,param);
    		System.out.println(url);
    		String resp = null;
    		try {
    			resp = URLUtil.get(url);
    		} catch (Exception e) {
    			e.printStackTrace();
    		} finally {
    			
    		}
    		System.out.println("QUERY VAC resp-----"+resp);
		} catch (Exception e) {
			e.printStackTrace();
		}
    	
    	
    	
    }
    

}
