package com.chinacreator.video.util;

import com.chinacreator.video.mapper.DictionaryDao;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.net.URLEncoder;
import java.util.HashMap;
import java.util.Map;

@Component
public class HxVipTwUtil {
	private static Logger ErrorLOGGER = LoggerFactory.getLogger("ERROR");
	@Autowired
	private DictionaryDao dictionaryDao;

	public  String vipid(String userid,String vipid,String channel,String pwd,String usertype,String userval,String orderid,String remark) {
		String resp = null;
		try {
			Map<String,String> param = new HashMap<>();
			String apptype = "2";
			String viptype = "2";
			String vipval = "1";
			String timeStamp = System.currentTimeMillis()/1000L+"";
			String signature = MD5.MD5Encode(orderid + channel + vipid + userval +pwd + timeStamp);
			
			param.put("apptype",apptype);
			param.put("orderid",orderid);
			param.put("vipid",vipid);
			param.put("channel",channel);
			param.put("usertype",usertype);
			param.put("userval",userval);
			param.put("vipval",vipval);
			param.put("viptype",viptype);
			param.put("signature",signature);
			param.put("timestamp",timeStamp);
			if(remark != null && !"".equals(remark)){
				if("4".equals(usertype)){
					param.put("remark",URLEncoder.encode(remark,"utf-8"));
				}else if("1".equals(usertype) || "2".equals(usertype) ||"3".equals(usertype)){
					param.put("remark",userid);
				}
			}
			param.put("timestamp",timeStamp);
			String  baseurl = dictionaryDao.getValue("videovipUrl");
			String url = URLUtil.mapToUrl(baseurl,param);
			resp = URLUtil.get(url,30000);
		} catch (Exception e) {
			ErrorLOGGER.error(e.getMessage());
			e.printStackTrace();
		} finally {
			
		}
		
		return resp;
	}
	

}
