package com.chinacreator.video.validate;
import org.apache.commons.lang.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import com.chinacreator.video.exception.BussinessException;
import com.chinacreator.video.mapper.ChannelControlDao;

/**
 * @author liujian
 */
@Component
public class ChannelOrderValidate {

	@Autowired
	private ChannelControlDao channelControlDao;
	
	public void channelValidate(String cpid,String spid,String channel,String province) throws BussinessException {
		if(StringUtils.isNotEmpty(province)) {
			String type = channelControlDao.getProvinceType(cpid, spid,province);
			if(StringUtils.isNotEmpty(type)) {
				if(type.equals("1")  && channelControlDao.isChanelControl(cpid, spid, channel, province)>0) {
					throw new BussinessException("9059", "该渠道暂未开放,请稍后再试");
				}
				if(type.equals("2") && channelControlDao.isChanelControl(cpid, spid, channel, province)==0) {
					throw new BussinessException("9059", "该渠道暂未开放,请稍后再试");
				}
			}else {
				if(channelControlDao.isChanelControl(cpid, spid, channel, province)>0) {
					throw new BussinessException("9059", "该渠道暂未开放,请稍后再试");
				}
			}
		}else {
			if(channelControlDao.isChanelControl(cpid, spid, channel, province)>0) {
				throw new BussinessException("9059", "该渠道暂未开放,请稍后再试");
			}
		}
	}
}
