package com.chinacreator.video.validate;

import com.chinacreator.video.bean.ChannelBean;
import com.chinacreator.video.exception.BussinessException;
import com.chinacreator.video.mapper.ChannelDao;
import org.springframework.beans.factory.annotation.Autowired;

public class ChannelValidate {

    @Autowired
    private ChannelDao channelDao;

    public void validate(String channel) throws Exception {
        if(org.apache.commons.lang.StringUtils.isEmpty(channel)) {
            throw new BussinessException("10023", "渠道参数不能为空");
        }
        ChannelBean channelBean = channelDao.queryChannel(channel);
        if(channelBean == null) {
            throw new BussinessException("10024", "渠道参数错误");
        }
    }

}
