package com.chinacreator.video.controller;

import java.util.Arrays;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import com.chinacreator.video.bean.*;
import com.chinacreator.video.mapper.ComplementSendDao;
import com.chinacreator.video.mapper.DictionaryDao;
import com.chinacreator.video.mapper.RaffleActivityConfigDao;
import com.chinacreator.video.redis.RedisService;
import com.chinacreator.video.service.ComplementSendService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import com.alibaba.fastjson.JSON;
import com.chinacreator.video.annotation.Log;
import com.chinacreator.video.dto.DataOutPipe;
import com.chinacreator.video.dto.QueryVipLogOutPipe;
import com.chinacreator.video.dto.QueryVipOutPipe;
import com.chinacreator.video.exception.BussinessException;
import com.chinacreator.video.service.ActivityMsgService;
import com.chinacreator.video.service.ContinueVipService;
import com.chinacreator.video.service.VipService;
import com.chinacreator.video.util.URLUtil;

@RestController
public class Activity {
//
//
//    @Autowired
//    private VipService activityService;
//
//    @Autowired
//    private ContinueVipService continueVipService;
//
//    @Autowired
//    private ActivityMsgService activityMsgService;
//
//    @Autowired
    private DictionaryDao dictionaryDao;
//
//    @Autowired
//    private RaffleActivityConfigDao raffleActivityConfigDao;
//
//    @Autowired
//    private ComplementSendService complementSendService;
//
//    @Autowired
//    RedisService redisService;
//
//    @Autowired
//    ComplementSendDao complementSendDao;
//
//    //单产品会员领取接口
//    @Log
//    @RequestMapping("/joinActivity")
//    public DataOutPipe<?> joinActivity(VipInfo activityInfo) throws BussinessException {
//        DataOutPipe<?> pipe = new DataOutPipe<>();
//        activityService.checkActity(activityInfo);
//        activityService.giveVip(activityInfo);
//        inserSmstMq(activityInfo);
//        return pipe;
//    }
//
//    /**
//     * vipnotify异步领取、续送
//     *
//     * @param vipLog
//     * @return
//     * @throws BussinessException
//     */
//    @Log
//    @RequestMapping("/asyncActivity")
//    public DataOutPipe<?> asyncActivity(@RequestBody VipLogBean vipLog) throws BussinessException {
//        DataOutPipe<?> pipe = new DataOutPipe<>();
//        ActivityLimitConfig config = raffleActivityConfigDao.getRaffleConfig("6");
//        activityService.checkIp(config);
//        // 主流程
//        activityService.asyncGiveVip(vipLog);
//        return pipe;
//    }
//
//    @Log
//    @RequestMapping("/queryActivity")
//    public QueryVipOutPipe queryActivity(VipInfo activityInfo) throws BussinessException {
//        QueryVipOutPipe queryVipOutPipe = new QueryVipOutPipe();
//        activityService.checkQueryActity(activityInfo);
//        activityService.queryVip(activityInfo);
//        queryVipOutPipe.setUserid(activityInfo.getUserid());
//        queryVipOutPipe.setUsertype(activityInfo.getUsertype());
//        queryVipOutPipe.setUserval(activityInfo.getUserval());
//        queryVipOutPipe.setVipname(activityInfo.getVipname());
//        return queryVipOutPipe;
//    }
//
//    @Log
//    @RequestMapping("/queryActivityMsg")
//    public QueryVipOutPipe queryActivityMsg(ActivityMsgBean activityMsgBean) throws BussinessException {
//        QueryVipOutPipe queryVipOutPipe = new QueryVipOutPipe();
//        activityMsgService.check(activityMsgBean);
//        if (activityMsgBean.getType().equals("0")) {
//            activityMsgService.giveMsg(activityMsgBean);
//        } else if (activityMsgBean.getType().equals("1")) {
//            activityMsgService.giveContinueMsg(activityMsgBean);
//        }
//        return queryVipOutPipe;
//    }
//
//    @Log
//    @RequestMapping("/reciveActivityMsg")
//    public QueryVipOutPipe receiveActivityMsg(ActivityMsgBean activityMsgBean) throws BussinessException {
//        QueryVipOutPipe queryVipOutPipe = new QueryVipOutPipe();
//        activityMsgService.checkRecive(activityMsgBean);
//        activityMsgService.revice(activityMsgBean);
//        return queryVipOutPipe;
//    }
//
//    @Log
//    @RequestMapping("/queryVipByChannel")
//    public DataOutPipe<?> queryVipByChannel(VipInfo activityInfo) throws BussinessException {
//        DataOutPipe<List<QueryVipLogOutPipe>> pipe = new DataOutPipe<>();
//        activityService.checkChannelQueryActity(activityInfo);
//        pipe.setData(activityService.queryVipLog(activityInfo));
//        return pipe;
//    }
//
//
//    @Log
//    @RequestMapping("/continueOrder")
//    public DataOutPipe<?> continueOrder(ContinueBean continueBean) throws BussinessException {
//        DataOutPipe<?> pipe = new DataOutPipe<>();
//        continueVipService.order(continueBean);
//        return pipe;
//    }
//
//    @Log
//    @RequestMapping("/continueVip")
//    public DataOutPipe<?> continueGivevip(ContinueBean continueBean) throws BussinessException {
//        DataOutPipe<?> pipe = new DataOutPipe<>();
//        continueVipService.checkContinueVip(continueBean);
//        continueVipService.continueGivehandle(continueBean);
//        return pipe;
//    }
//
    public void inserSmstMq(VipInfo activityInfo) {
        if (dictionaryDao.getValue("mqSendSmsVip") != null && Arrays.asList(dictionaryDao.getValue("mqSendSmsVip").split(",")).contains(activityInfo.getActivetype())) {
            try {
                Map<String, String> map = new HashMap<String, String>();
                map.put("userid", activityInfo.getUserid());
                map.put("cpid", activityInfo.getCpid());
                map.put("spid", activityInfo.getSpid());
                map.put("result", "0");
                map.put("channel", activityInfo.getChannel());
                //二级渠道
                map.put("subchannel", activityInfo.getSubchannel() == null ? "" : activityInfo.getSubchannel());
                //map.put("style",orderSmsMq.get(orderInfo.getSpid()));
                map.put("style", "0000");
                map.put("times", "");
                map.put("orderType", "");
                map.put("type", "cssms");
                map.put("busiType", "tran_vip");
                String mqReciveUrl = dictionaryDao.getValue("mqReciveUrl");
                URLUtil.post(mqReciveUrl, JSON.toJSONString(map));

            } catch (Exception e) {
                e.printStackTrace();
            }
        } else if (activityInfo.getActivetype().equals("18") || activityInfo.getActivetype().equals("20")) {
            try {
                Map<String, String> map = new HashMap<String, String>();
                map.put("userid", activityInfo.getUserid());
                map.put("cpid", "aiqy");
                map.put("spid", "1017");
                map.put("result", "0");
                map.put("channel", "");
                if (activityInfo.getActivetype().equals("18")) {
                    map.put("style", "14");
                } else if (activityInfo.getActivetype().equals("20")) {
                    map.put("style", "17");
                }
                map.put("times", "");
                map.put("orderType", "");
                map.put("type", "cssms");
                String mqReciveUrl = dictionaryDao.getValue("mqReciveUrl");
                URLUtil.post(mqReciveUrl, JSON.toJSONString(map));
            } catch (Exception e) {
                e.printStackTrace();
            }
        }
    }
//
//    public void inserContinueSmstMq(VipInfo activityInfo) {
//        try {
//            Map<String, String> map = new HashMap<String, String>();
//            map.put("userid", activityInfo.getUserid());
//            map.put("result", "0");
//            map.put("channel", "");
//            if (activityInfo.getActivetype().equals("20")) {
//                map.put("style", "18");
//                map.put("cpid", "aiqy");
//                map.put("spid", "1018");
//            } else if (activityInfo.getActivetype().equals("12")) {
//                map.put("style", "24");
//                map.put("cpid", "leshilt");
//                map.put("spid", "954");
//            } else if (activityInfo.getActivetype().equals("16")) {
//                map.put("style", "25");
//                map.put("cpid", "mangtv");
//                map.put("spid", "1006");
//            }
//            map.put("times", "");
//            map.put("orderType", "");
//            map.put("type", "cssms");
//            String mqReciveUrl = dictionaryDao.getValue("mqReciveUrl");
//            URLUtil.post(mqReciveUrl, JSON.toJSONString(map));
//        } catch (Exception e) {
//            e.printStackTrace();
//        }
//    }
//
//
//    /**
//     * 客服根据账期补送会员
//     *
//     * @return
//     * @throws BussinessException
//     */
//    @Log
//    @RequestMapping("/complementSend")
//    public DataOutPipe<?> complementSendVip(String id) throws Exception {
//        DataOutPipe<?> pipe = new DataOutPipe<>();
//        VipAccountBean vipAccount = new VipAccountBean();
//        vipAccount.setId(id);
//        try {
//            vipAccount = complementSendService.checkData(vipAccount);
//            complementSendService.checkSendVip(vipAccount);
//            complementSendService.sendVip(vipAccount);
//        } catch (Exception e) {
//            e.printStackTrace();
//            if (e instanceof BussinessException) {
//                if (!"0".equals(vipAccount.getVipstatus()) && !"3".equals(vipAccount.getVipstatus())) {
//                    String code = ((BussinessException) e).getCode();
//                    String message = e.getMessage();
//                    vipAccount.setResultcode(code);
//                    vipAccount.setErrorinfo(message);
//                    complementSendDao.updateCode(vipAccount);
//                }
//            }
//            redisService.removeKey("sendvip_" + vipAccount.getActivitytype() + "_" + vipAccount.getCpid() + "_" + vipAccount.getSpid() + "_" + vipAccount.getUserid());
//            throw e;
//        }
//        return pipe;
//    }
}
