package com.chinacreator.video.controller;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import com.chinacreator.video.annotation.Log;
import com.chinacreator.video.bean.VipInfo;
import com.chinacreator.video.dto.DataOutPipe;
import com.chinacreator.video.exception.BussinessException;
import com.chinacreator.video.service.VipMango3JSService;

@RestController
public class ActivityMango3JS {


	@Autowired
	private VipMango3JSService service;

	/**
	 * 会员领取
	 *
	 * @param activityInfo
	 * @return
	 * @throws BussinessException
	 */
	@Log
//	@RequestMapping("/vipjs/mango3/joinvip")
    public DataOutPipe<?> joinVip(VipInfo info) throws BussinessException {
		DataOutPipe<?> pipe = new DataOutPipe<>();

		try {
			service.checkVip(info);
			service.giveVip(info);
		} catch (Exception e) {
			service.removeRedis(info);
			throw e;
		}

		service.removeRedis(info);

        return pipe;
	}



}
