package com.chinacreator.video.mapper;

import com.chinacreator.video.bean.VipAccountBean;
import com.chinacreator.video.bean.VipLogBean;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * 账期补送会员
 *
 * @Author shuiying.ou
 * @Date 2022-12-12
 */
@Mapper
public interface ComplementSendDao {

    VipAccountBean findById(String id);

    /**
     *
     * @param invokeface
     * @return
     */
    String getLimitIp(String invokeface);

    List<VipLogBean> findVipLog(VipAccountBean vipAccount);

    void updateAccount(VipAccountBean vipAccount);

    String getRevipid(String vipid);

    /**
     * 获取领取vipid
     * @param spid
     * @param activetype
     * @return
     */
    String getvipid(@Param("spid") String spid , @Param("activetype") String activetype);

    String getVipConfig(String revipid);

    String getUrl(String invokename);

    String findVipLogByRequestid(String orderid);

    Integer findCount(VipAccountBean vipAccount);

    /**
     * 将未领取的置为失效
     * @param vipAccount
     */
    void updateStatus(VipAccountBean vipAccount);

    /**
     * 将置为失效的恢复为未领取
     * @param vipAccount
     */
    void updateReStatus(VipAccountBean vipAccount);

    List<String> findBySpid(VipAccountBean vipAccount);

    void updateCode(VipAccountBean vipAccount);

    void updateRequestid(VipAccountBean vipAccount);

    /**
     * 查询是否为合约包
     * @param spid
     * @return
     */
    String getDirectype(String spid);

    void updateReplace(VipAccountBean vipAccount);
}
