package com.chinacreator.video.mapper;

import org.apache.ibatis.annotations.Param;

import com.chinacreator.video.bean.HxProduct;
import com.chinacreator.video.bean.HxOrder;


public interface HxOrderDao {
	
	/**
	 * 查询产品信息
	 * 
	 * @param goodscode
	 * @return
	 */
	public HxProduct getProdcutBean(@Param("cpid")String cpid,@Param("spid")String spid);
	
	/**
	 * 查询订单信息
	 * 
	 * @param userid
	 * @param goodscode
	 * @param orderid
	 * @return
	 */
	public HxOrder getOrderBean(@Param("userid")String userid,@Param("orderid")String orderid,@Param("cpid")String cpid,@Param("spid")String spid);
	
	/**
	 * 
	 * @param userid
	 * @param orderid
	 * @param cpid
	 * @param spid
	 * @return
	 */
	public HxOrder getOrderTwBean(@Param("userid")String userid,@Param("orderid")String orderid,@Param("cpid")String cpid,@Param("spid")String spid);
	
	/**
	 * 修改会员领取状态-成功
	 * 
	 * @param userid
	 * @param goodscode
	 * @param orderid
	 */
	public void giveSuccess(@Param("userid")String userid,@Param("orderid")String orderid,@Param("cpid")String cpid,@Param("spid")String spid);
	
	/**
	 * 修改会员领取状态-成功
	 * 
	 * @param userid
	 * @param goodscode
	 * @param orderid
	 */
	public void giveFail(@Param("userid")String userid,@Param("orderid")String orderid,@Param("cpid")String cpid,@Param("spid")String spid);
	
	/**
	 * 修改会员领取状态-成功
	 * 
	 * @param userid
	 * @param goodscode
	 * @param orderid
	 */
	public void giveTwSuccess(@Param("userid")String userid,@Param("orderid")String orderid,@Param("cpid")String cpid,@Param("spid")String spid,@Param("vipusertype")String vipusertype,@Param("vipuserval")String vipuserval);
	
	/**
	 * 修改会员领取状态-成功
	 * 
	 * @param userid
	 * @param goodscode
	 * @param orderid
	 */
	public void giveTwFail(@Param("userid")String userid,@Param("orderid")String orderid,@Param("cpid")String cpid,@Param("spid")String spid,@Param("vipusertype")String vipusertype,@Param("vipuserval")String vipuserval);
}
