package com.chinacreator.video.mapper;


import com.chinacreator.video.bean.ActivityGiftBean;
import com.chinacreator.video.bean.ActivityLimitConfig;
import org.apache.ibatis.annotations.Param;
import org.springframework.cache.annotation.CacheConfig;
import org.springframework.cache.annotation.Cacheable;

import java.util.List;

@CacheConfig(cacheNames = "RaffleActiveConfig")
public interface RaffleActivityConfigDao {

    @Cacheable
    ActivityLimitConfig getRaffleConfig(@Param("activityid")String activityid);


    @Cacheable
    List<ActivityGiftBean> getGiftConfig();


}
