package com.chinacreator.video.mapper;

import java.util.HashMap;
import java.util.List;

import org.springframework.cache.annotation.CacheConfig;
import org.springframework.cache.annotation.Cacheable;

/**
 * 手动送会员配置信息
 * @author xu.zhou
 * @date 20220223
 */
@CacheConfig(cacheNames = "videoactivity-vipjoinspidconf")
public interface VipJoinSpidDao {

	@Cacheable
	List<HashMap> getVipJoinSpidConf(String spid);
}
